(*
  ˂œ鍏
  Easy: 700, Normal&Hard: 1000, Lunatic: 1200
 *)

type difficulty =
  | Normal
  | Hard
  | Lunatic

let compute_get_fullmoon d =
  let
      graze_bonus,                      (* {[iX *)
      scb,                              (* XyJ[h{[iX *)
      graze1,                           (* ˖ڂ̂萔 *)
      graze2,                           (* j˖ڂ̂萔 *)
      graze,                            (* ȍ~̂萔 *)
      last_time,                        (* jɓ鍏̐ *)
      time_point                        (* ̓_ *)
      =
    match d with
    | Normal -> 500, 21000000, 50, 110, 60, 1600, 11520
    | Hard -> 600, 22000000, 55, 115, 65, 1700, 11790
    | Lunatic -> 750, 23000000, 60, 120, 70, 1800, 12140 in
  let total_graze = graze1 + graze2 + graze * 12 in
  let total_time = total_graze * 3 + last_time in
  scb + total_graze * (4000 + graze_bonus) + total_time * time_point
    (* , total_graze, total_time *)

let compute_not_get_fullmoon d bomb =
  let bomb = min bomb 6 in
  let
      bomb_bonus,                       (* c{{[iX *)
      graze_bonus,
      graze1,
      _graze,
      graze,                            (* {̂萔 *)
      time,                             (* ˂Ŏɓ鍏̐ *)
      last_time,
      time_point
      =
    match d with
    | Normal -> 5000000, 500, 50, 60, 110, 1000, 1600, 11520
    | Hard -> 6000000, 600, 55, 65, 115, 1000, 1700, 11790
    | Lunatic -> 7500000, 750, 60, 70, 120, 1200, 1800, 12140 in
  let real_graze = time / 3 in       (* ǂEGrazeɉZȂ
                                        肪ۂ *)
  let _total_graze = _graze * ((6 - bomb) * 2) in
  let _total_time = _total_graze * 3 in
  let total_graze = graze1 + graze * bomb in
  let total_real_graze = graze1 + real_graze * bomb in
  let total_time = time * (bomb * 2) + last_time in
  _total_graze * (4000 + graze_bonus)
  + total_graze * graze_bonus + total_real_graze * 4000
  + (_total_time + total_time) * time_point
  - bomb_bonus * bomb
    (* ,_total_graze, _total_time, total_graze, total_real_graze, total_time *)

let _ =
  let d = ref Normal in
  let bomb = ref 0 in
  print_endline "^̌̃{҂͂ǂ̂炢҂̂ZovOB";
  let rec loop () =
    print_endline "Փx́Hi[]̒̐́BEnter̂ݑłƏI܂BEasyɂ͑ΉĂ܂j";
    print_endline "[1]Normal [2]Hard [3]Lunatic";
    begin
      match read_line () with
      | "1" ->
          d := Normal;
          print_endline "NormalˁB";
      | "2" ->
          d := Hard;
          print_endline "HardˁB";
      | "3" ->
          d := Lunatic;
          print_endline "LunaticˁB";
      | "" -> exit 0
      | _ ->
          d := Normal;
          print_endline "NormalɂB";
    end;
    print_endline "{͂ƍlH";
    begin
      try
        bomb := int_of_string (read_line ());
      with
        Failure "int_of_string" ->
          print_endline "ĂƂɂ܂B";
    end;
    let get = compute_get_fullmoon !d in
    let not_get = compute_not_get_fullmoon !d !bomb in
    Printf.printf "{sgp:  %10d_\n" get;
    Printf.printf "{%dgp: %10d_i%+d_j\n" (min !bomb 6) not_get (not_get - get);
    loop ();
  in
  loop ()
